"use strict";
import mongoose from "mongoose";
const { Schema } = mongoose;
const assert = require("assert");
const { MongooseFindByReference } = require("../src/main");

run().catch(console.error);

async function run() {
  await mongoose.connect("mongodb://localhost:27017/test");

  await mongoose.connection.dropDatabase();

  const userSchema = new Schema({
    timestamps: { createdAt: { type: Date } },
    pet: { type: Schema.Types.ObjectId, ref: "Cat" },
  });

  userSchema.plugin(MongooseFindByReference);

  const User = mongoose.model("User", userSchema);

  const Cat = mongoose.model(
    "Cat",
    new Schema({
      name: String,
    })
  );

  const cat = await Cat.create({ name: "Ray" });

  await User.create({
    timestamps: {
      createdAt: new Date("2022-07-04T09:18:07.647Z"),
    },
    pet: cat._id,
  });
  const users = await User.find({
    // "timestamps.createdAt": {
    //   $gte: new Date("1994-01-01T00:00:00Z"),
    //   $lte: new Date("2222-01-01T00:00:00Z"),
    // },
    "pet.name": "Ray",
  });

  assert.equal(users.length, 1);

  console.log("Assertions passed.");
}
